//+------------------------------------------------------------------+
//|                                                 Ost_Channals.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Ostapjuk Nikolaj"
#property link      "middle@fxmail.ru"
//----
#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 MediumSeaGreen
#property indicator_color2 MediumSeaGreen
#property indicator_color3 SlateBlue
#property indicator_color4 SlateBlue
#property indicator_color5 Maroon
//---- input parameters 
extern int       fast    =3;
extern int       per     =26;
extern int       smooth  =8;
//---- buffers 
double ExtMapBuffer0[];
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer6[];
double Yshift[];
//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
int init()
  {
//---- indicators 
   IndicatorBuffers(7);
   SetIndexStyle(0,DRAW_LINE,2);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexDrawBegin(0,per);
   SetIndexStyle(1,DRAW_LINE,2);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexDrawBegin(1,per);
   SetIndexStyle(2,DRAW_LINE,2);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexDrawBegin(2,per);
   SetIndexStyle(3,DRAW_LINE,2);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexDrawBegin(3,per);
   SetIndexStyle(4,DRAW_LINE,2);
   SetIndexBuffer(4,ExtMapBuffer6);
   SetIndexDrawBegin(4,per);
   SetIndexShift(4,-per);
   SetIndexBuffer(5,ExtMapBuffer0);
   SetIndexBuffer(6,Yshift);
//---- 
   return(0);
  }
//+------------------------------------------------------------------+ 
//| Custom indicator deinitialization function                       | 
//+------------------------------------------------------------------+ 
int deinit()
  {
//---- 
//---- 
   return(0);
  }
//+------------------------------------------------------------------+ 
//| Custom indicator iteration function                              | 
//+------------------------------------------------------------------+ 
int start()
  {
   int    counted_bars=IndicatorCounted();
//---- 
   int limit,limit1,cnt,n_max,n_min;
   if (counted_bars==0)
     {
      limit=Bars-per;
      limit1=limit-per;
     }
   if (counted_bars>0)
     {
      limit=Bars-counted_bars;
      limit1=limit;
     }
   limit--;
   limit1--;
   for(cnt=limit; cnt>=0;cnt--)
     {
      ExtMapBuffer0[cnt]=iMA(NULL,0,fast,0,MODE_LWMA,PRICE_MEDIAN,cnt); 
      Yshift[cnt]=(High[iHighest(NULL,0,MODE_HIGH,per,cnt+1)]-Low[iLowest(NULL,0,MODE_LOW,per,cnt+1)])/2.0;
     }
   for(cnt=limit1; cnt>=0;cnt--)
     {
    //  double Yshift=(High[iHighest(NULL,0,MODE_HIGH,per,cnt+1)]-Low[iLowest(NULL,0,MODE_LOW,per,cnt+1)])/2.0;
      ExtMapBuffer1[cnt]=iMAOnArray(ExtMapBuffer0,0,smooth*2,0,MODE_SMA,cnt) + iMAOnArray(Yshift,0,smooth*2,0,MODE_SMA,cnt);
      ExtMapBuffer2[cnt]=iMAOnArray(ExtMapBuffer0,0,smooth*2,0,MODE_SMA,cnt) - iMAOnArray(Yshift,0,smooth*2,0,MODE_SMA,cnt);
     }
     for(cnt=limit1; cnt>=0;cnt--)
     {
     
      ExtMapBuffer3[cnt]=iMAOnArray(ExtMapBuffer1,0,smooth,0,MODE_SMA,cnt) + iMAOnArray(Yshift,0,smooth*2,0,MODE_SMA,cnt);
      ExtMapBuffer4[cnt]=iMAOnArray(ExtMapBuffer2,0,smooth,0,MODE_SMA,cnt) - iMAOnArray(Yshift,0,smooth*2,0,MODE_SMA,cnt);
     }
//---- Chinkou Span
   int i=Bars-1;
   if(counted_bars>1) i=Bars-counted_bars-1;
   while(i>=0) { ExtMapBuffer6[i]=iMA(NULL,0,fast,0,MODE_LWMA,PRICE_MEDIAN,i);//Close[i]; 
   i--; }
//---- 
   return(0);
  }
//+------------------------------------------------------------------+

